#include <stdlib.h>

#include "ListaSimples.h"

typedef struct TNo {
	char * elem;
	struct TNo * proximo;
} * NoImpl;

typedef struct TListaSimples {
	NoImpl primeiro;
} * ListaSimplesImpl;


ListaSimples criarListaSimples() {
	ListaSimplesImpl lista = (ListaSimplesImpl)malloc(sizeof(struct TListaSimples));
	lista->primeiro = NULL;
}

void adicionarListaSimples(ListaSimples lista, char * elem, int pos) {
	ListaSimplesImpl listaImpl = (ListaSimplesImpl)lista;
	NoImpl no = listaImpl->primeiro;

	if (pos) {
		while ((--pos > 0) && (no != NULL)) no = no->proximo;
		if (no != NULL) {
			NoImpl novoNo = (NoImpl)malloc(sizeof(struct TNo));
			novoNo->elem = elem;
			novoNo->proximo = no->proximo;
			no->proximo = novoNo;
		}
	}
	else {
		no = (NoImpl)malloc(sizeof(struct TNo));
		no->elem = elem;
		no->proximo = listaImpl->primeiro;
		listaImpl->primeiro = no;
	}
}

char * obterListaSimples(ListaSimples lista, int pos) {
	ListaSimplesImpl listaImpl = (ListaSimplesImpl)lista;
	NoImpl no = listaImpl->primeiro;

	while ((pos-- > 0) && (no != NULL)) no = no->proximo;
	return (no != NULL) ? no->elem : NULL;
}

void removerListaSimples(ListaSimples lista, int pos) {
	ListaSimplesImpl listaImpl = (ListaSimplesImpl)lista;
	NoImpl no = listaImpl->primeiro;

	if ((pos == 0) && (no != NULL)) {
		listaImpl->primeiro = no->proximo;
		free(no);
	}
	else {
		while ((pos-- > 1) && (no != NULL)) no = no->proximo;
		NoImpl noRemover = (no != NULL) ? no->proximo : NULL;
	
		if (noRemover != NULL) {
			no->proximo = noRemover->proximo;
			free(noRemover);
		}
	}
}

void destruirListaSimples(ListaSimples lista) {
	ListaSimplesImpl listaImpl = (ListaSimplesImpl)lista;
	NoImpl no = listaImpl->primeiro;

	while (no != NULL) {
		NoImpl noRemover = no;
		no = no->proximo;
		free(noRemover);
	}
	
	free(lista);
}
