#include <stdlib.h>

#include "PilhaVetor.h"

typedef struct TPilhaVetor {
	char ** elems;
	int topo;
} * PilhaVetorImpl;

PilhaVetor criarPilhaVetor(int tamanho) {
	PilhaVetorImpl pilha = (PilhaVetorImpl)malloc(sizeof(struct TPilhaVetor));

	pilha->elems = (char **)malloc(tamanho * sizeof(char *));
	pilha->topo = 0;

	return pilha;
}

void empilharPilhaVetor(PilhaVetor pilha, char * elem) {
	PilhaVetorImpl pilhaImpl = (PilhaVetorImpl)pilha;
	pilhaImpl->elems[pilhaImpl->topo++] = elem;
}

char * desempilharPilhaVetor(PilhaVetor pilha) {
	PilhaVetorImpl pilhaImpl = (PilhaVetorImpl)pilha;
	if (pilhaImpl->topo > 0) return pilhaImpl->elems[--pilhaImpl->topo];
	else return NULL;
}

void destruirPilhaVetor(PilhaVetor pilha) {
	PilhaVetorImpl pilhaImpl = (PilhaVetorImpl)pilha;
	free(pilhaImpl->elems);
	free(pilhaImpl);
}
